@ECHO OFF
REM CHKBoot.BAT -- ensures Boot not damaged, repairs if it is.
REM last updated by Roedy Green 91/09/23
REM insert in AUTOEXEC.BAT to check Boot sector ok.
REM Must have done a BootSAVE C:\Boot.SAV first

C:\SYS\BootChk.COM C:\Boot.SAV
IF NOT Errorlevel 1 GOTO DONE

REM Boot check failed:
REM could be 4 reasons:

REM 1. Never set up Boot.SAV before

REM 2. Boot.SAV has been deleted

REM 3. Boot sector has been illegitimately tampered with

IF NOT EXIST C:\Boot.SAV GoTo MakeIt

Echo Abort now with Ctrl-Break if you do not wish to restore damaged Boot sector
Pause

REM Presume reason 3, try restoring

C:\SYS\BootREST.COM C:\Boot.SAV
IF NOT Errorlevel 1 GOTO Reboot
Echo Boot is still corrupted
Pause
:Reboot
C:\SYS\Reboot.Com

:MakeIt

REM Build a NEW Boot.SAV file
Echo Missing Boot.SAV file.  Recreating it.
Pause
C:\SYS\BootSAVE.COM C:\Boot.SAV
Echo You might also want to create a new A: Rescue floppy boot disk soon
Echo Use BootSAVE A:\Boot.SAV
Pause

:DONE
REM -30-
